#if 0 

    Copyright (c) 1991 SGI   All Rights Reserved
    THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SGI
    The copyright notice above does not evidence any
    actual or intended publication of such source code,
    and is an unpublished work by Silicon Graphics, Inc.
    This material contains CONFIDENTIAL INFORMATION that
    is the property of Silicon Graphics, Inc. Any use,
    duplication or disclosure not specifically authorized
    by Silicon Graphics is strictly prohibited.
    
    RESTRICTED RIGHTS LEGEND:
    
    Use, duplication or disclosure by the Government is
    subject to restrictions as set forth in subdivision
    (c)(1)(ii) of the Rights in Technical Data and Computer
    Software clause at DFARS 52.227-7013, and/or in similar
    or successor clauses in the FAR, DOD or NASA FAR
    Supplement.  Unpublished- rights reserved under the
    Copyright Laws of the United States.  Contractor is
    SILICON GRAPHICS, INC., 2011 N. Shoreline Blvd.,
    Mountain View, CA 94039-7311

#endif
/*
    ilSquareImg is derived from ilArithLutImg and performs pixelwise Square
    of an ilImage.
*/

#ifndef _ilSquareImg_h_
#define _ilSquareImg_h_

#include <il/ilArithLutImg.h>


class ilSquareImg : public ilArithLutImg {
public:
    iflClassListDeclare
    // external api: begin
    ilSquareImg(ilImage* inImg = NULL);
    // external api: end
    ~ilSquareImg();
    
protected:
    void resetOp();
    void loadLut();
    void calcRow(iflDataType inType, void* ilBuf, void* outBuf, 
		 int sx, int lim, int x,
		 int y, int z, int c, ilMpCacheRequest& req);
};

#endif
